/*

updated as of 4/30/11 - included shower script


  Web client
 
 This sketch connects to a website (http://www.google.com)
 using an Arduino Wiznet Ethernet shield. 
 
 Circuit:
 * Ethernet shield attached to pins 10, 11, 12, 13
 
 created 18 Dec 2009
 by David A. Mellis
 
 */



#include <SPI.h>
#include <Ethernet.h>

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {  0x90, 0xA2, 0xDA, 0x00, 0x38, 0x04 };
byte ip[] = { 192,168,1,177 };
//byte server[] = { 173,194,33,104 }; // Google
byte server[] = { 67,222,18,93 }; // iwearshorts



// Initialize the Ethernet client library
// with the IP address and port of the server 
// that you want to connect to (port 80 is default for HTTP):
Client client(server, 80);

long inches = 11;

// shower
int inputPin = 2;               // choose the input pin (for PIR sensor)
int pirState = LOW;             // we start, assuming no motion detected
int val = 0;                    // variable for reading the pin status
int flag = 0;

void setup() {

// reset pin
pinMode(9, OUTPUT); // resest
pinMode(7, OUTPUT); // ping pin

// start the Ethernet connection:
  Ethernet.begin(mac, ip);
  // start the serial library:
  Serial.begin(9600);
    
  // shower 
  pinMode(inputPin, INPUT);     // declare sensor as input
  


}

void loop()
{
  val = digitalRead(inputPin);  // read input value
  if (val == HIGH) {            // check if the input is HIGH
//    digitalWrite(ledPin, HIGH);  // turn LED ON
    if (pirState == LOW) {
      // we have just turned on
      Serial.println("Motion detected!");
      
      if(flag == 0) {
        flag = 1; 
        Serial.println("in the shower");
        // we want to notify the server of a shower update
        callServer("1", "infrared");
        client.flush();
        client.stop();
        delay(5000);
      } else if(flag == 1) {
        flag = 0;
        Serial.println("out of the shower");
        // we want to notify the server of a shower update
        callServer("0", "infrared");
        client.flush();
        client.stop();
        delay(5000);
      }
      // We only want to print on the output change, not state
      pirState = HIGH;
    }
  } else {
//    digitalWrite(ledPin, LOW); // turn LED OFF
    if (pirState == HIGH){
      // we have just turned of
      Serial.println("Motion ended!");
      
      // We only want to print on the output change, not state
      pirState = LOW;
    }
  }
  
  // if no motion, start monitoring the bathroom
  Serial.println("pinging...");
  // send a sonar ping
  pingSonar();

}

void pingSonar() {
  // establish variables for duration of the ping, 
  // and the distance result in inches and centimeters:
  long duration, inches, cm;
  
  const int pingPin = 7;

  // The PING))) is triggered by a HIGH pulse of 2 or more microseconds.
  // Give a short LOW pulse beforehand to ensure a clean HIGH pulse:
  pinMode(pingPin, OUTPUT);
  digitalWrite(pingPin, LOW);
  delayMicroseconds(2);
  digitalWrite(pingPin, HIGH);
  delayMicroseconds(5);
  digitalWrite(pingPin, LOW);

  // The same pin is used to read the signal from the PING))): a HIGH
  // pulse whose duration is the time (in microseconds) from the sending
  // of the ping to the reception of its echo off of an object.
  pinMode(pingPin, INPUT);
  duration = pulseIn(pingPin, HIGH);

  // convert the time into a distance
  inches = microsecondsToInches(duration);
  
  String inchesStr = inches;
  
  Serial.println("ping returned: "+ inchesStr +"...");
  
  // show LED colors
  if(inches < 35 && inches > 0) {
    // then the person is sitting
     callServer(inchesStr, "sonar");
     responseLoop();
  } else {
    // do nothing...
  }
  Serial.println();
  delay(3000);
}

void responseLoop () {
  for(int i = 0; i < 1200; i++) {
       // delay the timer
                        // BEGIN IF STATEMENTS FROM LOOP
                          
                        // if there are incoming bytes available 
                        // from the server, read them and print them:
                        if (client.available()) {

                            char c = client.read();
                            Serial.print(c);
                          
                        }
     delay(1);
        
   } // end for loop
                      
    // if the server's disconnected, stop the client:
    if (!client.connected()) {
      Serial.println();
      Serial.println("disconnecting.");
      client.stop();
       
    }
    delay(560000);
      // END IF STATEMENTS FROM LOOP
        
}

void callServer (String inchesStr, String type) {

  
  String str = "http://iwearshorts.com/bathroom/process.php?measurement="+ inchesStr +"&type=" + type;
  
  // give the Ethernet shield a second to initialize:
  delay(1000);
  Serial.println("connecting...");

  // if you get a connection, report back via serial:
  if (client.connect()) {
    Serial.println("connected");
    Serial.println("Calling: "+ str);
    
    // Make a HTTP request:
    client.println("GET "+ str +" HTTP/1.0");
    client.println();
    
  } else {
    // kf you didn't get a connection to the server:
    Serial.println("connection failed: " + str);
  } 
  
  
}

long microsecondsToInches(long microseconds)
{
  // According to Parallax's datasheet for the PING))), there are
  // 73.746 microseconds per inch (i.e. sound travels at 1130 feet per
  // second).  This gives the distance travelled by the ping, outbound
  // and return, so we divide by 2 to get the distance of the obstacle.
  // See: http://www.parallax.com/dl/docs/prod/acc/28015-PING-v1.3.pdf
  return microseconds / 74 / 2;
}

long microsecondsToCentimeters(long microseconds)
{
  // The speed of sound is 340 m/s or 29 microseconds per centimeter.
  // The ping travels out and back, so to find the distance of the
  // object we take half of the distance travelled.
  return microseconds / 29 / 2;
}

